#!/bin/bash

#
# Quick and dirty script to download the Apple IIGS roms needed for the GSport
# emulator - Greg.
#
# TODO: get gsport to respect XDG spec.
# Adhere to XDG Base Directory Specification
# https://standards.freedesktop.org/basedir-spec/basedir-spec-latest.html

[[ -z $XDG_DATA_HOME ]] && XDG_DATA_HOME="$HOME/.local/share"
[[ -z $XDG_CONFIG_HOME ]] && XDG_CONFIG_HOME="$HOME/.config"

# Get from mirrors.apple2.org.za. Shameless plug :)
#
if [[ ! -f "$XDG_DATA_HOME/gsport/ROM.01" ]]; then
    echo 'Downloading ROM.01...'
    curl -s --create-dirs -o "$XDG_DATA_HOME/gsport/ROM.01" \
        http://mirrors.apple2.org.za/apple.cabi.net/GS.Emulators/GS.ROM.IMAGES/GS.01.ROM
fi

if [[ ! -f "$XDG_DATA_HOME/gsport/ROM.03" ]]; then
    echo 'Downloading ROM.03...'
    curl -s --create-dirs -o "$XDG_DATA_HOME/gsport/ROM.03" \
        http://mirrors.apple2.org.za/apple.cabi.net/GS.Emulators/GS.ROM.IMAGES/GS.03.ROM
fi

# Update config file with correct path to ROM.
#
if [[ -f "$XDG_DATA_HOME/gsport/ROM.03" ]]; then

    [[ ! -d "${XDG_CONFIG_HOME}/gsport" ]] && mkdir -p "${XDG_CONFIG_HOME}/gsport"
    
    CONFIG_FILE="${XDG_CONFIG_HOME}/gsport/config.txt"
    if [[ ! -f "${CONFIG_FILE}" ]]; then
        cp /usr/share/gsport/config.txt.dist "${CONFIG_FILE}"
        echo "Updating config file ${CONFIG_FILE}"
        sed -i -e "s|^g_cfg_rom_path.*|g_cfg_rom_path = $XDG_DATA_HOME/gsport/ROM.03|" "${CONFIG_FILE}"
    fi
fi

